/* S1 microprogram simulation

   Prabhas Chongstitvatana
   Department of Computer Engineering
   Chulalongkorn University

   17 July 98
*/

#include "s1m.h"

char ms[MXMS][MSW]; 	/* micro store */
int  mpc;		/* micro PC */

int  R[8], Ir, Mdr, Mar, Pc, T, Z, S, M[1024];
int  trace, core, start, nbyte;   /* control display */
int  bus,p1,p2;          	 /* internal bus, alu ports */

/* this is not a good style
   but make it simpler to compile */
#include "supportm.c"

int set(int pos )	/* test current ms is set at pos */
{
  return( ms[mpc][pos] == '1' );
}


/* decode instruction to microprogram address */

int udop[] =  {ULOAD,USTORE,UJMP,UJAL,UNDEF,UNDEF,UNDEF,UNDEF};
int udxop[] = {UMOV,ULOADR,USTORER,UADD,UCMP,UINC,UJR,UTRAP};

int udecode()
{
  if( IRop() != IXOP ) 	 return udop[ IRop() ];
  if( IRxop() <= ITRAP ) return udxop[ IRxop() ];
  return UNDEF;
}

int ugoto()	/* decode Goto field */
{
  int a = 0;
  if( set(GOTO) )   a = 16;
  if( set(GOTO+1) ) a += 8;
  if( set(GOTO+2) ) a += 4;
  if( set(GOTO+3) ) a += 2;
  if( set(GOTO+4) ) a += 1;
  return a;
}

/* alu op input a, b . affect cond code Z,S  */
void alu(char op, int a,int b)
{
  switch(op) {
  case '+': T = a+b; break;
  case '-': T = a-b; break;
  case 'p': T = a;   break;
  case 'i': T = a+1; break;
  }
  if( T == 0 ) Z = 1; else Z = 0;
  if( T < 0 )  S = 1; else S = 0;
}

int testCc( int cond )	/* test condition code */
{
  switch( cond ) {    	/*  -,z,nz,lt,le,ge,gt */
  case 0: return 1;	/*  0,1, 2, 3, 4, 5, 6 */
  case 1: return Z;
  case 2: return !Z;
  case 3: return S;
  case 4: return S || Z;
  case 5: return !S || Z;
  case 6: return !S;
  }
  return 0;
}

/* run events of each field with the following sequence :
	selR  find index of registers
	src to bus
	bus to dest
	alu to T
	mctl
	next microword
*/
void run()
{
  int mnext, rx;	/* next mpc, rx R index */

  while(1) {
/*    if( trace ) showms(); */
    clock++;
    if( mpc == UIFETCH) ninst++;
    if( mpc == UTRAP )  trap(IRr1());
    if( mpc == UNDEF ) 	trap(UNDEF);
    if( set(IRR0) ) 	rx = IRr();
    if( set(IRR1) ) 	rx = IRr1();
    if( set(IRR2) ) 	rx = IRr2();
    if( set(IR12) )   { p1 = R[IRr1()]; p2 = R[IRr2()]; }
    if( set(SR) ) 	bus = R[rx];
    if( set(SPC) ) 	bus = Pc;
    if( set(SIR) ) 	bus = IRads();
    if( set(SMAR) ) 	bus = Mar;
    if( set(SMDR) ) 	bus = Mdr;
    if( set(ST) ) 	bus = T;
    if( set(DR) ) 	R[rx] = bus;
    if( set(DPC) ) 	Pc = bus;
    if( set(DIR) ) 	Ir = bus;
    if( set(DMAR) ) 	Mar = bus;
    if( set(DMDR) ) 	Mdr = bus;
    if( set(PASS1) ) 	alu('p',p1,p2);
    if( set(ADD) ) 	alu('+',p1,p2);
    if( set(SUB) ) 	alu('-',p1,p2);
    if( set(ADD1) ) 	alu('i',p1,p2);
    if( set(MRD) ) 	Mdr = M[Mar];
    if( set(MWR) ) 	M[Mar] = Mdr;
    if( set(PC1) ) 	Pc = Pc + 1;
    mnext = -1;
    if( set(U) ) 	mnext = ugoto();
    if( set(MRDY) ) ;   /* assume no wait */
    if( set(TESTCC) )
     if(!testCc(IRr())) mnext = ugoto();
    if( set(DECODE) )  	mnext = udecode();
    if( mnext == -1 )  	mpc++; else mpc = mnext;
    if( mpc == UIFETCH && trace ) show();
  }
}

main()
{
  readmpgm();
  trace = 0;
  core = 0;
  loadprogram();
  Pc = 0;
  Z = 0;
  S = 0;
  mpc = UIFETCH;
  clock = 0; ninst = 0;
  run();
}
